/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.compute.models;

/**
* Parameters supplied to the Register Extension Image operation.
*/
public class ExtensionImageRegisterParameters extends ExtensionImage {
    /**
    * Initializes a new instance of the ExtensionImageRegisterParameters class.
    *
    */
    public ExtensionImageRegisterParameters() {
        super();
    }
    
    /**
    * Initializes a new instance of the ExtensionImageRegisterParameters class
    * with required arguments.
    *
    * @param providerNameSpace Required. The provider namespace of the
    * extension.
    * @param type Required. The type of the extension.
    * @param version Required. The version of the extension.
    */
    public ExtensionImageRegisterParameters(String providerNameSpace, String type, String version) {
        this();
        if (providerNameSpace == null) {
            throw new NullPointerException("providerNameSpace");
        }
        if (type == null) {
            throw new NullPointerException("type");
        }
        if (version == null) {
            throw new NullPointerException("version");
        }
        this.setProviderNameSpace(providerNameSpace);
        this.setType(type);
        this.setVersion(version);
    }
}
