/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.scheduler.models;

import java.util.Calendar;

/**
* Specifies service bus brokered message properties.
*/
public class JobServiceBusBrokeredMessageProperties {
    private String contentType;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ContentType.
    * @return The ContentType value.
    */
    public String getContentType() {
        return this.contentType;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ContentType.
    * @param contentTypeValue The ContentType value.
    */
    public void setContentType(final String contentTypeValue) {
        this.contentType = contentTypeValue;
    }
    
    private String correlationId;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * CorrelationId.
    * @return The CorrelationId value.
    */
    public String getCorrelationId() {
        return this.correlationId;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * CorrelationId.
    * @param correlationIdValue The CorrelationId value.
    */
    public void setCorrelationId(final String correlationIdValue) {
        this.correlationId = correlationIdValue;
    }
    
    private boolean forcePersistence;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ForcePersistence.
    * @return The ForcePersistence value.
    */
    public boolean isForcePersistence() {
        return this.forcePersistence;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ForcePersistence.
    * @param forcePersistenceValue The ForcePersistence value.
    */
    public void setForcePersistence(final boolean forcePersistenceValue) {
        this.forcePersistence = forcePersistenceValue;
    }
    
    private String label;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties Label.
    * @return The Label value.
    */
    public String getLabel() {
        return this.label;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties Label.
    * @param labelValue The Label value.
    */
    public void setLabel(final String labelValue) {
        this.label = labelValue;
    }
    
    private String messageId;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * MessageId.
    * @return The MessageId value.
    */
    public String getMessageId() {
        return this.messageId;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * MessageId.
    * @param messageIdValue The MessageId value.
    */
    public void setMessageId(final String messageIdValue) {
        this.messageId = messageIdValue;
    }
    
    private String partitionKey;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * PartitionKey.
    * @return The PartitionKey value.
    */
    public String getPartitionKey() {
        return this.partitionKey;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * PartitionKey.
    * @param partitionKeyValue The PartitionKey value.
    */
    public void setPartitionKey(final String partitionKeyValue) {
        this.partitionKey = partitionKeyValue;
    }
    
    private String replyTo;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ReplyTo.
    * @return The ReplyTo value.
    */
    public String getReplyTo() {
        return this.replyTo;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ReplyTo.
    * @param replyToValue The ReplyTo value.
    */
    public void setReplyTo(final String replyToValue) {
        this.replyTo = replyToValue;
    }
    
    private String replyToSessionId;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ReplyToSessionId.
    * @return The ReplyToSessionId value.
    */
    public String getReplyToSessionId() {
        return this.replyToSessionId;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ReplyToSessionId.
    * @param replyToSessionIdValue The ReplyToSessionId value.
    */
    public void setReplyToSessionId(final String replyToSessionIdValue) {
        this.replyToSessionId = replyToSessionIdValue;
    }
    
    private Calendar scheduledEnqueueTimeUtc;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ScheduledEnqueueTimeUtc.
    * @return The ScheduledEnqueueTimeUtc value.
    */
    public Calendar getScheduledEnqueueTimeUtc() {
        return this.scheduledEnqueueTimeUtc;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ScheduledEnqueueTimeUtc.
    * @param scheduledEnqueueTimeUtcValue The ScheduledEnqueueTimeUtc value.
    */
    public void setScheduledEnqueueTimeUtc(final Calendar scheduledEnqueueTimeUtcValue) {
        this.scheduledEnqueueTimeUtc = scheduledEnqueueTimeUtcValue;
    }
    
    private String sessionId;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * SessionId.
    * @return The SessionId value.
    */
    public String getSessionId() {
        return this.sessionId;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * SessionId.
    * @param sessionIdValue The SessionId value.
    */
    public void setSessionId(final String sessionIdValue) {
        this.sessionId = sessionIdValue;
    }
    
    private Calendar timeToLive;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * TimeToLive.
    * @return The TimeToLive value.
    */
    public Calendar getTimeToLive() {
        return this.timeToLive;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * TimeToLive.
    * @param timeToLiveValue The TimeToLive value.
    */
    public void setTimeToLive(final Calendar timeToLiveValue) {
        this.timeToLive = timeToLiveValue;
    }
    
    private String to;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties To.
    * @return The To value.
    */
    public String getTo() {
        return this.to;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties To.
    * @param toValue The To value.
    */
    public void setTo(final String toValue) {
        this.to = toValue;
    }
    
    private String viaPartitionKey;
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ViaPartitionKey.
    * @return The ViaPartitionKey value.
    */
    public String getViaPartitionKey() {
        return this.viaPartitionKey;
    }
    
    /**
    * Optional. Gets or sets the service bus brokered message properties
    * ViaPartitionKey.
    * @param viaPartitionKeyValue The ViaPartitionKey value.
    */
    public void setViaPartitionKey(final String viaPartitionKeyValue) {
        this.viaPartitionKey = viaPartitionKeyValue;
    }
}
